# Generated by Django 2.2.9 on 2020-01-17 15:39

import uuid

import django.contrib.postgres.fields.jsonb
import enumfields.fields
from django.db import migrations, models
from enumfields import Enum

import arkindex.dataimport.models
import arkindex.project.aws
import arkindex.project.fields
import arkindex_common.enums


class EventType(Enum):
    Addition = 'A'
    Edit = 'M'
    Deletion = 'D'

class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='DataFile',
            fields=[
                ('hash', arkindex.project.fields.MD5HashField(max_length=32)),
                ('status', enumfields.fields.EnumField(default='unchecked', enum=arkindex.project.aws.S3FileStatus, max_length=50)),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=100)),
                ('size', models.PositiveIntegerField(help_text='file size in bytes')),
                ('content_type', models.CharField(max_length=50)),
            ],
            options={
                'ordering': ['corpus', 'name'],
            },
            bases=(arkindex.project.aws.S3FileMixin, models.Model),
        ),
        migrations.CreateModel(
            name='DataImport',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('mode', enumfields.fields.EnumField(enum=arkindex_common.enums.DataImportMode, max_length=30)),
                ('payload', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
            ],
            options={
                'ordering': ['corpus', '-created'],
            },
        ),
        migrations.CreateModel(
            name='Event',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('type', enumfields.fields.EnumField(enum=EventType, max_length=10)),
            ],
            options={
                'ordering': ['element_id', '-created'],
            },
        ),
        migrations.CreateModel(
            name='Repository',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('url', models.URLField(unique=True)),
                ('hook_token', models.CharField(max_length=250, unique=True)),
                ('provider_name', models.CharField(choices=[('GitLabProvider', 'GitLab')], max_length=50)),
            ],
            options={
                'verbose_name_plural': 'repositories',
            },
        ),
        migrations.CreateModel(
            name='Revision',
            fields=[
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ('hash', models.CharField(max_length=50)),
                ('ref', models.CharField(max_length=50)),
                ('message', models.TextField()),
                ('author', models.CharField(max_length=50)),
            ],
        ),
    ]
